Program circuit;
Uses TestLib;
{Input: obtained by TestLib operations}
{Output: TName.stt produced by calls of TestLib operation}
{Interface to TestLib:
MSG:String; grading message
TInF:Text; input file of the test case, opened for reading if appropriate
ToutF:text; output file of the test case, opened for reading if appropriate
CoutF:Text; contestant's output file, exists and opened for reading if RunOK
}
Var t:Integer; {# test cases}

Function Eval:Boolean;
Const
  MaxN=10000;
Type
  Point=Record x,y:Integer End;
Var
  N,i,j:Integer;
  X,Y:Longint;
  P:Array[1..MaxN] of Point;
  S:Array[1..MaxN] of Longint;

Procedure ReadIn;
Var i,X:Integer;
Begin
  ReadLn(TInF, N);
  For i:=1 To N Do Begin
    Read(TInF, P[i].x,P[i].y);
  End;
  ReadLn(TInF);
End{ReadIn};

Function CrossT(i1,i2,j1,j2:Word):Boolean;
Var P1L,P1U,P2L,P2U,Q1,Q2,Q3:Point;
  Q1Q2,Q3Q2:Longint;
  Function XP(P1,P2:Point):Longint;
  Begin
    XP:=P1.x*P2.y-P2.x*P1.y
  End;
Begin{CrossT}
  CrossT:=False;
  P1L.x:=P[i1].x; If P[i2].x<P[i1].x Then P1L.x:=P[i2].x;
  P2L.x:=P[j1].x; If P[j2].x<P[j1].x Then P2L.x:=P[j2].x;
  P1L.y:=P[i1].y; If P[i2].y<P[i1].y Then P1L.y:=P[i2].y;
  P2L.y:=P[j1].y; If P[j2].y<P[j1].y Then P2L.y:=P[j2].y;

  P1U.x:=P[i1].x; If P[i2].x>P[i1].x Then P1U.x:=P[i2].x;
  P2U.x:=P[j1].x; If P[j2].x>P[j1].x Then P2U.x:=P[j2].x;
  P1U.y:=P[i1].y; If P[i2].y>P[i1].y Then P1U.y:=P[i2].y;
  P2U.y:=P[j1].y; If P[j2].y>P[j1].y Then P2U.y:=P[j2].y;
  If Not((P1U.x>=P2L.x)And(P2U.x>=P1L.x)And(P1U.y>=P2L.y)And(P2U.y>=P2L.y)) Then Exit;

  Q1.x:=P[j1].x-P[i1].x; Q1.y:=P[j1].y-P[i1].y;
  Q2.x:=P[i2].x-P[i1].x; Q2.y:=P[i2].y-P[i1].y;
  Q3.x:=P[j2].x-P[i1].x; Q3.y:=P[j2].y-P[i1].y;
  Q1Q2:=XP(Q1,Q2);
  Q3Q2:=XP(Q3,Q2);
  CrossT:=Not((Q3Q2<0)And(Q1Q2<0) Or (Q3Q2>0)And(Q1Q2>0));
End;{CrossT}

Begin{Eval}
  Eval:=False;

  ReadIn;

  For i:=1 To N Do Begin
    {$I-}
    Read(COutF, X);
    {$I+}
    If IOResult<>0 Then Begin
      WriteMSG(1,'HIBA: Output Fomtum hiba');
      Exit;
    End;
    If (X<1)Or(X>N) Then Begin
      WriteMSG(1,'HIBA: Hibs sorszm');
      Exit;
    End;

    S[i]:=X;
  End{for i};
  ReadLn(COutF);

  For i:=3 To N Do Begin
    For j:=2 To i Do Begin
      If CrossT(S[j-1],S[j],S[i-1],S[i]) Then Begin
       WriteMSG(1,'HIBA: keresztez szakaszok'); 
       exit;
      End; 
    End{for j};
  End{for i};
  For i:=1 To N-1 Do Begin
    If CrossT(S[1],S[N],S[i],S[i+1]) Then Begin
      WriteMSG(1,'HIBA: keresztez szakaszok'); 
      exit;
    End; 

  End{for i};

  Grade(1,1);
  WriteMSG(1,'HELYES');

End{Eval};

Begin{}
  For t:=1 To TCase Do Begin
    If Not Eval Then
      Done;
  End{for t};
  Done;
End.
